stages:
  - install
  - analysis
  - build
  - publish
  - deploy

.dependencies_cache:
  cache:
    key:
      files:
        - packages-lock.json
      prefix: $CI_COMMIT_BRANCH
    paths:
      - .npm
    policy: pull

install-dependencies:
  stage: install
  image: node:17
  script:
    - npm ci --cache .npm --prefer-offline
  extends: .dependencies_cache
  cache:
    policy: pull-push
  only:
    changes:
      - packages-lock.json
    variables:
      - $INSTALL_DEPENDENCIES == "true"

build-test-docker-image:
  stage: install
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/test.Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}/test:chrome"
  only:
    changes:
      - test.Dockerfile
    variables:
      - $REBUILD_TEST_DOCKER_IMAGE == "true"

eslint:
  stage: analysis
  image: node:17
  before_script:
    - npm ci --cache .npm --prefer-offline
  script:
    - npm run lint
  extends: .dependencies_cache

test:
  stage: analysis
  image: ${CI_REGISTRY_IMAGE}/test:chrome
  dependencies:
    - build-test-docker-image
  before_script:
    - npm ci --cache .npm --prefer-offline
  script:
    - npm run test
  artifacts:
    when: always
    reports:
      junit:
        - junit/test-results.xml
    expire_in: 30 days
  extends: .dependencies_cache

dev_app:
  stage: build
  image: node:17
  before_script:
    - npm ci --cache .npm --prefer-offline
  script:
    - npm run build
  artifacts:
    name: "dev-app"
    expire_in: 30 days
    paths:
      - ./dist/radio-cheatsheet-generator
  extends: .dependencies_cache

pages_app:
  stage: build
  image: node:17
  before_script:
    - npm ci --cache .npm --prefer-offline
  script:
    - npm run build-pages
  artifacts:
    name: "pages-app"
    expire_in: 30 days
    paths:
      - ./dist/radio-cheatsheet-generator
  extends: .dependencies_cache
  only:
    - main

docker-image:
  stage: publish
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  dependencies:
    - dev_app
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/app.Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}/app:latest"

pages:
  stage: deploy
  script:
    - mv ./dist/radio-cheatsheet-generator $CI_PROJECT_DIR/public
  artifacts:
    paths:
      - public
  dependencies:
    - pages_app
  environment:
    name: prod
    url: https://d.pfeil.gitlab.io/radio-cheatsheet-generator
  when: manual
  only:
    - main
